<template>
  <ResizePageWrapper :hasLeft="false">
    <template #resizeRight>
      <BasicTable @register="registerTable" isMenuTable ref="tableRef">
        <template #toolbar>
          <template v-for="button in tableButtonConfig" :key="button.code">
            <a-button v-if="button.isDefault" type="primary" @click="buttonClick(button.code)">
              <template #icon><Icon :icon="button.icon" /></template>
              {{ button.name }}
            </a-button>
            <a-button
              v-else
              :type="button.buttonType === 'danger' ? 'default' : button.buttonType || 'primary'"
              :danger="button.buttonType === 'danger'"
              @click="buttonClick(button.code)"
            >
              <template #icon><Icon :icon="button.icon" /></template>
              {{ button.name }}
            </a-button>
          </template>
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.componentType === 'switch'">
            <a-switch
              v-model:checked="record[column.dataIndex]"
              :unCheckedValue="0"
              :checkedValue="1"
              :disabled="true"
            />
          </template>

          <template v-if="column.dataIndex === 'action'">
            <TableAction
              :actions="getLessActions(record)"
              :dropDownActions="getMoreActions(record)"
            />
          </template>

          <template v-else-if="column.staticOptions?.length">
            <span :style="executeListStyle(record, column?.listStyle)">
              {{
                column.staticOptions.filter((x) => x.value === record[column.dataIndex])[0]?.label
              }}
            </span>
          </template>
          <template v-else-if="column.dataIndex && column?.listStyle">
            <span :style="executeListStyle(record, column?.listStyle)">{{
              record[column.dataIndex]
            }}</span>
          </template>
        </template>
      </BasicTable>
    </template>

    <CustomCompModal @register="registerModal" @success="handleSuccess" />
    <CategoryModal
      title="组件"
      dicId="1881874836500508673"
      @register="registerItemModal"
      @success="reload"
    />
  </ResizePageWrapper>
</template>
<script lang="ts" setup>
  import { ref, computed, createVNode } from 'vue';

  import { Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import { BasicTable, useTable, TableAction, ActionItem } from '/@/components/Table';
  import { getCustomCompPage, deleteCustomComp } from '/@/api/system/customcomp';
  import { ResizePageWrapper } from '/@/components/Page';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { usePermission } from '/@/hooks/web/usePermission';
  import { executeListStyle } from '/@/hooks/web/useListStyle'; //列表样式配置
  import { useRouter } from 'vue-router';

  import { useModal } from '/@/components/Modal';

  import CustomCompModal from './components/CustomCompModal.vue';
  import { CategoryModal } from '/@/components/CategoryModal';
  import { searchFormSchema, columns } from './components/config';

  import Icon from '/@/components/Icon/index';

  const listSpliceNum = ref(3); //操作列最先展示几个

  const { notification } = useMessage();
  const { t } = useI18n();
  defineEmits(['register']);
  const { filterColumnAuth, filterButtonAuth, hasPermission } = usePermission();
  const [registerItemModal, { openModal: openItemModal }] = useModal();
  const filterColumns = filterColumnAuth(columns);
  const tableRef = ref();
  const pageParamsInfo = ref<any>({});

  //展示在列表内的按钮
  const actionButtons = ref<string[]>(['view', 'edit', 'delete']);
  const buttonConfigs = computed(() => {
    const list = [
      {
        buttonId: '1881632204578816000',
        name: '查看',
        code: 'view',
        icon: 'ant-design:eye-outlined',
        isDefault: true,
        isUse: true,
      },
      {
        buttonId: '1881632204578816001',
        name: '新增',
        code: 'add',
        icon: 'ant-design:plus-outlined',
        isDefault: true,
        isUse: true,
      },
      {
        buttonId: '1881632204578816002',
        name: '编辑',
        code: 'edit',
        icon: 'ant-design:form-outlined',
        isDefault: true,
        isUse: true,
      },
      {
        isUse: true,
        name: '分类管理',
        code: 'typeManage',
        icon: 'ant-design:apartment-outlined',
        isDefault: false,
        setting: [],
        showType: 'top',
        buttonType: 'primary',
      },
      {
        buttonId: '1881632204578816003',
        name: '删除',
        code: 'delete',
        icon: 'ant-design:delete-outlined',
        isDefault: true,
        isUse: true,
      },
    ];
    return filterButtonAuth(list);
  });

  const tableButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => !actionButtons.value.includes(x.code));
  });

  const actionButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => actionButtons.value.includes(x.code));
  });

  const btnEvent = {
    view: handleView,
    add: handleAdd,
    edit: handleEdit,
    delete: handleDelete,
    typeManage: handleItemCreate,
  };

  const { currentRoute } = useRouter();

  const formIdComputedRef = computed(() => currentRoute.value.meta.formId as string);

  const [registerModal, { openModal }] = useModal();

  const [registerTable, { reload }] = useTable({
    title: 'CustomComp列表',
    api: getCustomCompPage,
    rowKey: 'id',
    columns: filterColumns,
    formConfig: {
      labelWidth: 100,
      schemas: searchFormSchema,
      fieldMapToTime: [],
      showResetButton: false,
    },
    beforeFetch: (params) => {
      pageParamsInfo.value = { ...params, FormId: formIdComputedRef.value, PK: 'id' };
      return pageParamsInfo.value;
    },
    afterFetch: () => {},
    useSearchForm: true,
    showTableSetting: true,

    striped: false,
    actionColumn: {
      width: 180,
      title: '操作',
      dataIndex: 'action',
      slots: { customRender: 'action' },
    },
    tableSetting: {
      size: false,
    },
    customRow,
    isAdvancedQuery: false,
    querySelectOption: JSON.stringify(searchFormSchema),
    objectId: formIdComputedRef.value, ////系统表单formId,自定义表单releaseId的id值
  });

  function buttonClick(code) {
    btnEvent[code]();
  }
  function handleItemCreate() {
    openItemModal(true, { title: t('自定义组件分类管理') });
  }
  function handleAdd() {
    openModal(true, { isUpdate: false });
  }

  async function handleEdit(record: Recordable) {
    let field = 'id';

    let info = {
      id: record[field],
      isUpdate: true,
    };

    openModal(true, info);
  }

  function handleDelete(record: Recordable) {
    deleteList([record.id]);
  }

  function deleteList(ids) {
    Modal.confirm({
      title: '提示信息',
      icon: createVNode(ExclamationCircleOutlined),
      content: '是否确认删除？',
      okText: '确认',
      cancelText: '取消',
      onOk() {
        deleteCustomComp(ids).then((_) => {
          handleSuccess();
          notification.success({
            message: 'Tip',
            description: t('删除成功！'),
          });
        });
      },
      onCancel() {},
    });
  }

  function customRow(record: Recordable) {
    return {
      ondblclick: () => {
        if (record.isCanEdit && hasPermission('customcomp:edit')) {
          handleEdit(record);
        }
      },
    };
  }

  function handleSuccess() {
    reload();
  }

  function handleView(record: Recordable) {
    let info = {
      isView: true,
      id: record.id,
    };

    openModal(true, info);
  }

  function getLessActions(record: Recordable) {
    let list = getActions(record);
    return list.slice(0, listSpliceNum.value);
  }
  function getMoreActions(record: Recordable) {
    let list = getActions(record);
    return list.slice(listSpliceNum.value);
  }
  function getActions(record: Recordable): ActionItem[] {
    record.isCanEdit = false;

    const actionsList: ActionItem[] = actionButtonConfig.value?.map((button) => {
      if (!record?.workflowData?.processId) {
        record.isCanEdit = true;
        return {
          auth: `customcomp:${button.code}`,
          label: button?.name,
          color: button.code === 'delete' ? 'error' : undefined,
          onClick: btnEvent[button.code]?.bind(null, record),
        };
      } else {
        if (button.code === 'view') {
          return {
            auth: `customcomp:${button.code}`,
            label: button?.name,
            onClick: btnEvent[button.code].bind(null, record),
          };
        } else {
          return {};
        }
      }
    });
    return actionsList;
  }
</script>
<style lang="less" scoped>
  :deep(.ant-table-selection-col) {
    width: 50px;
  }

  .show {
    display: flex;
  }

  .hide {
    display: none !important;
  }
</style>
